﻿#include "CWindow.h"
#include "CDSPro81.h"

#define DEBUGMODE
#include "debug.h"


// グローバル変数
CWindow		win;		// ウィンドウ
CDSPro81	ds;			// DirectSound



// メインルーチン
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdParam, int nCmdShow)
{
	INITDEBUG();
	CLEARDEBUG();

	// ウインドウ
	if( !win.Create( hInstance,L"TestDirectSound - [Z]BASS [X]SNARE [C]CLOSE-HAT [V]OPEN-HAT",TRUE,640,480) ) {
		DEBUG( "ウィンドウエラー\n" );
        return -1;
	}

	// COMの初期化
	CoInitialize( NULL );

	// DirectSound
	if( !ds.Create(win.hWnd) ) {
		// COMの終了
		CoUninitialize();
		return -1;
	}

	// サウンドの追加
	ds.AddSound( 0,"bgm.wav" );
	ds.AddSound( 1,"closehihat.wav" );
	ds.AddSound( 2,"openhihat.wav" );
	ds.AddSound( 3,"snare.wav" );
	ds.AddSound( 4,"bass.wav" );

	// 起動時の再生
	ds.Play( 0,TRUE );

	BOOL bOn[4] = { FALSE,FALSE,FALSE,FALSE };		// 連続押し回避
	MSG msg;
	while(1) {
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			if (msg.message == WM_QUIT) {
				DEBUG("WM_QUIT\n","");
				break;
			}
			TranslateMessage(&msg);
        	DispatchMessage(&msg);
		}

		BYTE key[256];
		GetKeyboardState( key );

		if( key[VK_ESCAPE]&0x80 )
			break;

		// オープンハイハット
		if( key['V']&0x80 ) {
			if( !bOn[0] ) {
				bOn[0] = TRUE;
				ds.Reset( 2 );
				ds.Play( 2 );
			}
		} else {
			bOn[0] = FALSE;
		}

		// クローズハイハット
		if( key['C']&0x80 ) {
			if( !bOn[1] ) {
				bOn[1] = TRUE;
				ds.Reset( 1 );
				ds.Play( 1 );
			}
		} else {
			bOn[1] = FALSE;
		}

		// スネア
		if( key['X']&0x80 ) {
			if( !bOn[2] ) {
				bOn[2] = TRUE;
				ds.Reset( 3 );
				ds.Play( 3 );
			}
		} else {
			bOn[2] = FALSE;
		}

		// バス
		if( key['Z']&0x80 ) {
			if( !bOn[3] ) {
				bOn[3] = TRUE;
				ds.Reset( 4 );
				ds.Play( 4 );
			}
		} else {
			bOn[3] = FALSE;
		}

		Sleep(3);
	}

	ds.Delete();

	// COMの終了
	CoUninitialize();

	win.Delete();

	return 0;
}
